import { alt_sc } from "typescript-parsec";
import {
  ARRAY_DEFINITION_RULE,
  CLASS_DECLARATION_RULE,
  CLASS_DEFINITION_RULE,
  COMPOUND_STATEMENT_RULE,
  COMPUTED_ARRAY_DEFINITION_RULE,
  COMPUTED_ELEMENTARY_TYPE_DEFINITION_RULE,
  DO_STATEMENT_RULE,
  ELEMENTARY_TYPE_DEFINITION_RULE,
  EXPRESSION_STATEMENT_RULE,
  FOR_STATEMENT_RULE,
  IF_STATEMENT_RULE,
  MAP_DECLARATION_RULE,
  MAP_DEFINITION_RULE,
  STRING_DEFINITION_RULE,
  SWITCH_STATEMENT_RULE,
  WHILE_STATEMENT_RULE,
} from "../syntax_rules.ts";

export function getStatementPattern() {
  return alt_sc(
    EXPRESSION_STATEMENT_RULE,
    COMPOUND_STATEMENT_RULE,
    ELEMENTARY_TYPE_DEFINITION_RULE,
    MAP_DECLARATION_RULE,
    MAP_DEFINITION_RULE,
    STRING_DEFINITION_RULE,
    CLASS_DEFINITION_RULE,
    CLASS_DECLARATION_RULE,
    ARRAY_DEFINITION_RULE,
    COMPUTED_ELEMENTARY_TYPE_DEFINITION_RULE,
    COMPUTED_ARRAY_DEFINITION_RULE,
    IF_STATEMENT_RULE,
    SWITCH_STATEMENT_RULE,
    FOR_STATEMENT_RULE,
    DO_STATEMENT_RULE,
    WHILE_STATEMENT_RULE,
  );
}
